#pragma once

#include <Punkt.h>
#include <Model3DCollection.h>
#include <Reader.h>
#include <Model3D.h>
#include <Array.h>
#include <Critical.h>

#include "Block.h"
#include "Area.h"

class Chunk : public Framework::Model3DCollection
{
private:
    int dimensionId;
    Framework::Punkt location;
    Framework::RCArray<Block> blocks;
    bool isLoading;
    Framework::Critical cs;

public:
    Chunk( Framework::Punkt location, int dimensionId );
    Chunk( Framework::Punkt location, int dimensionId, Framework::StreamReader* zReader );
    ~Chunk();
    Block* zBlockAt( Framework::Vec3<int> cLocation );
    void setBlock( Block* block );
    void removeBlock( Block* zBlock );
    void load( Framework::StreamReader* zReader );
    int getDimensionId() const;
    Framework::Punkt getCenter() const;
    Framework::Vec3<int> getMin() const;
    Framework::Vec3<int> getMax() const;
    void forAll( std::function<void( Model3D* )> f ) override;
    void updateVisibility();
};