#pragma once

#include <Text.h>
#include "Entity.h"
#include "StaticRegistry.h"

class ItemSlot;

class Player : public Entity
{
private:
    Framework::Text name;
    Framework::Array<ItemSlot*> itemBar;

public:
    Player();
    ~Player();

    virtual bool tick( double time ) override;
};

class PlayerEntityType : public EntityType
{
    REGISTRABLE( PlayerEntityType )

protected:
    virtual void loadSuperEntity( Entity* zEntity, Framework::StreamReader* zReader ) const override;
    virtual Entity* createEntity() const override;

public:
    PlayerEntityType();
};

REGISTER( PlayerEntityType, EntityType )